//+------------------------------------------------------------------+
//|                                      Sue's Inside Bar.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Alex Dunmow"
#property link      "http://www.99thmonkey.net"
#property indicator_minimum -100
#property indicator_maximum 0
extern double       TakeProfit=200.0;
extern double       StopLoss=75.0;
extern double       Lots=0.5;
extern int          OpenOrders=1;
extern int          MagicNumber=1234;
extern bool         CloseOnOpposite = true;
extern double       ADXTrendLevel=20;
extern int          TrailingStop=30;

double sLoss;
double TProfit;
double price;
int ticket;
int openSells;
int openBuys;
datetime Timestamp = 0;

double SMA;
double SMA4;
double SMA15;
string Trend;

//double SAR;
//double SAR1;
//string Parabolic;

double ATR;
string ATRange;
double Bar1;
double Bar2;
double Bar3;
double BullBar1;
double BullBar2;
double BullBar3;
double BearBar1;
double BearBar2;
double BearBar3;
string Candle;
double Stoch0;
double Stoch1;
double Stoch2;
double Stoch3;
string Stochastic;
string BuySignal;

double OpenPrice;
double ClosePrice;

//double AWS;
//double AWS1;
//double AWS2;
string Awesome;

double ADX;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
	//----
	//----
	return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
	//----
	//----
	return(0);
}

int start() {

if(Timestamp != iTime(NULL,0,0))
   {
      Timestamp = iTime(NULL,0,0);
         
         ADX=iADX(NULL,0,20,PRICE_CLOSE,MODE_MAIN,1);
         ATR=iATR(NULL,0,PERIOD_H1,1);
         Stoch1=iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_MAIN,1);
         Stoch2=iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_MAIN,2);
         Stoch3=iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_MAIN,3); 
      	OpenPrice=iOpen(NULL,0,0);
	  	   ClosePrice=iClose(NULL,0,0);

		   SMA=iMA(NULL,0,55,0,MODE_SMA, PRICE_WEIGHTED,1);
		   SMA4=iMA(NULL,PERIOD_H4,55,0,MODE_SMA, PRICE_WEIGHTED,1);
		   SMA15=iMA(NULL,PERIOD_M15,55,0,MODE_SMA, PRICE_WEIGHTED,1);
		   if(OpenPrice>SMA && OpenPrice>SMA4 && OpenPrice>SMA15)
		   {
		   Trend="Long";
		   }
		   if(OpenPrice<SMA && OpenPrice<SMA4 && OpenPrice<SMA15)
		   {
		   Trend="Short";
		   }		   
		   if(iOpen(NULL,0,3)>iClose(NULL,0,3)) { 
		    BullBar3=true;
		   } else {
		    BullBar3=false;
		   }
		   if(iHigh(NULL,0,2)<=iHigh(NULL,0,3) && iLow(NULL,0,2)>=iLow(NULL,0,3) && iOpen(NULL,0,2)<iClose(NULL,0,2)) { 
		    BullBar2=true;
		   } else {
		    BullBar2=false;
		   }
		   if(Ask-2*Point > iHigh(NULL,0,2)) { 
		    BullBar1=true;
		   } else {
		    BullBar1=false;
		   }
		   
		   if(BullBar3==true && BullBar2==true && BullBar1==true)
		   {
		   Candle="Long";
         }
         
         if(iOpen(NULL,0,3)<iClose(NULL,0,3)) { 
		    BearBar3=true;
		   } else {
		    BearBar3=false;
		   }
		   if(iHigh(NULL,0,2)<=iHigh(NULL,0,3) && iLow(NULL,0,2)>=iLow(NULL,0,3) && iOpen(NULL,0,2)>iClose(NULL,0,2)) { 
		    BearBar2=true;
		   } else {
		    BearBar2=false;
		   }
		   if(Bid+2*Point < iLow(NULL,0,1)) { 
		    BearBar1=true;
		   } else {
		    BearBar1=false;
		   }
		   
		   if(BearBar3==true && BearBar2==true && BearBar1==true)
		   {
		   Candle="Short";
         }
         
         if(Stoch1>80 || Stoch2>80 || Stoch3>80)
         {
            Stochastic="Short";
         }
         if(Stoch1<20 || Stoch2 <20 || Stoch3<20)
         {
            Stochastic="Long";
         }
         
  /*     
         if (iAO(NULL,0,2)>iAO(NULL,0,1) || iAO(NULL,0,0)<-0.001) {
         Awesome="Short";
         }
         if (iAO(NULL,0,2)<iAO(NULL,0,1) || iAO(NULL,0,0)>0.001) {
         Awesome="Long";
         }
*/               
		int orders = OrdersTotal();
		openSells = 0;
		openBuys = 0;
		int i;
      for(i=0;i<OrdersTotal();i++){
         if(OrderSelect(i, SELECT_BY_POS)) {
            if (OrderType() == OP_BUY) {
               openBuys++;
            } else {
               openSells++;
            }
         }
      }		
     CheckTrailingStop();

   //Close if trend ends
      
      if(CloseOnOpposite)
       {
         if(ClosePrice>SMA)
         {
            CloseAllShorts();
         }
         if(ClosePrice<SMA)
         {
            CloseAllLongs();
         }
      }
      
    
		//if all options met
			if (Stochastic=="Long" && ADX>ADXTrendLevel && Trend=="Long" && Candle=="Long") {
			   if (openBuys < OpenOrders) {
				  if (StopLoss != 0) {
					  sLoss = Ask-StopLoss*Point;
				  } else {
					  sLoss = Ask-2*ATR;
				  }
				  if (TakeProfit != 0) {
					  TProfit = Ask+TakeProfit*Point;
				  } else {
					  TProfit = Ask+5*ATR;
				  }
					   ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,sLoss,TProfit,"WilliamsSkalperBuy",MagicNumber,0,Green);
					   setTrailingStop();
					  }
				  }
			if(Stochastic=="Short" && ADX>ADXTrendLevel && Trend=="Short" && Candle=="Short") {
			   if (openSells < OpenOrders) {
			      if (StopLoss != 0) {
					   sLoss = Bid+StopLoss*Point;
				   } else {
					   sLoss = Bid+2*ATR;
				   }
				  if (TProfit != 0) {
					  TProfit = Bid-TakeProfit*Point;
				  } else {
					  TakeProfit = Bid-5*ATR;
				  }
				  ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,sLoss,TProfit,"WilliamsSkalperSell",MagicNumber,0,Red);
				  setTrailingStop();
				  }
			}   
	return(0);
}
}


//Close all tickets
int CloseAllLongs()
      {
         for(int i=0;i<OrdersTotal();i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_BUY)
         {
         OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, White );
         }
      }
   return(0);
}

int CloseAllShorts()
{
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_SELL)
      {
         OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, White );
      }
   }
  
   return(0);
}

void CheckTrailingStop()
      {
      for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      
      if(OrderSymbol()!=Symbol()) continue;
   
      if(OrderType() == OP_BUY)
         {
         if(((Bid - OrderOpenPrice()) > (Point * TrailingStop)) && (OrderStopLoss() < (Bid - Point * TrailingStop)))
            OrderModify(
                        OrderTicket(),
                        OrderOpenPrice(),
                        Bid - Point * TrailingStop,
                        OrderTakeProfit(),
                        0,
                        SkyBlue);
         }
      
      if(OrderType() == OP_SELL)
         {
         if(((OrderOpenPrice() - Ask) > (Point * TrailingStop)) && (OrderStopLoss() > (Ask + Point * TrailingStop)))
            OrderModify(
                        OrderTicket(),
                        OrderOpenPrice(),
                        Ask + Point * TrailingStop,
                        OrderTakeProfit(),
                        0,
                        Orange);
         }    
      }
return(0);
      }


      int setTrailingStop()
         {
         for(int i=0;i<OrdersTotal();i++)
         {
         if(TrailingStop>0)
         {
         OrderSelect(i,SELECT_BY_TICKET);
     
         if((Bid-OrderOpenPrice())>((Point*TrailingStop)))
         {
        if(OrderStopLoss()<Bid-Point*TrailingStop)
          {
           OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(Point*TrailingStop),OrderTakeProfit(),0,Blue);
           return(0);
          }
       }
       if((Ask+OrderOpenPrice()<(Point*TrailingStop)))
       {
        if(OrderStopLoss()>Ask+(Point*TrailingStop))
          {
           OrderModify(OrderTicket(),OrderOpenPrice(),Ask+(Point*TrailingStop),OrderTakeProfit(),0,Blue);
           return(0);
          }
       }
     }
   }
    return(0);
}

